﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using ModbusDemo.MessageFormat;
using ModbusDemo.Common;
using System.Collections;
using MQTTnet;
using MQTTnet.Client;
using Newtonsoft.Json;
using ModbusDemo;

namespace ModbusDemo.Modular
{
    class ModualPoll
    {
#if DEBUG_TEST
        public const byte byX14pNumber = 1;
        public static byte[] byX14pIdlist = { 27 };
        private static modual.eX14pSensorChannelType[,] sX14pChannelType = new modual.eX14pSensorChannelType[byX14pNumber, byX14pReadTypeNumber] { { modual.eX14pSensorChannelType.Normal, modual.eX14pSensorChannelType.Null, modual.eX14pSensorChannelType.Null, modual.eX14pSensorChannelType.Null } };
#else
        public const byte  byX14pNumber                                  = 2;
        public static byte[] byX14pIdlist = { 1,17};
        private static modual.eX14pSensorChannelType[,] sX14pChannelType = new modual.eX14pSensorChannelType[byX14pNumber, byX14pReadTypeNumber] { { modual.eX14pSensorChannelType.Normal, modual.eX14pSensorChannelType.Null, modual.eX14pSensorChannelType.Null, modual.eX14pSensorChannelType.Null },                                                                                                                                               { modual.eX14pSensorChannelType.Normal, modual.eX14pSensorChannelType.Null, modual.eX14pSensorChannelType.Null, modual.eX14pSensorChannelType.Null }};
#endif
        private const byte byX14pReadDataStartAddress = 0;
        public const byte byX14pReadDataNumber = 4;
        private const byte byX14pReadTypeStartAddress = 10;
        private const byte byX14pReadTypeNumber = 4;
        public const double dX14pMinCovertData = 0;
        public const double dx14pMaxConverData = 60;
        public const ushort us14pMaxJumTemper = 10;
        public static modual.pcx14P cx14P = new modual.pcx14P(byX14pIdlist, sX14pChannelType);
        public static _414P c14formulasormual = new _414P();
#if DEBUG_TEST
        public const byte byX18xNumber    = 1;
        public static byte[] byX18xIdlist = {13,14};
        private static modual.eX18xSensorChannelType[,] sX18xChannelType = new modual.eX18xSensorChannelType[byX18xNumber, byX18xReadDataNumber] { { modual.eX18xSensorChannelType.NormalCurrent, modual.eX18xSensorChannelType.Null, modual.eX18xSensorChannelType.NormalCurrent, modual.eX18xSensorChannelType.Null, modual.eX18xSensorChannelType.Null, modual.eX18xSensorChannelType.Null, modual.eX18xSensorChannelType.Null, modual.eX18xSensorChannelType.Null } };
#else
        public  const byte  byX18xNumber                                 = 6;
        public static byte[] byX18xIdlist                                = {3,53,6,12,21,25};
        private static modual.eX18xSensorChannelType[,] sX18xChannelType =  new modual.eX18xSensorChannelType[byX18xNumber, byX18xReadDataNumber]{{modual.eX18xSensorChannelType.Weiertai,modual.eX18xSensorChannelType.Null,modual.eX18xSensorChannelType.Mike_7,modual.eX18xSensorChannelType.Null,modual.eX18xSensorChannelType.Null,modual.eX18xSensorChannelType.Null,modual.eX18xSensorChannelType.Null,modual.eX18xSensorChannelType.Null},            //东中转池     ID  3
                                                                                                                                                  {modual.eX18xSensorChannelType.NormalCurrent,modual.eX18xSensorChannelType.Null,modual.eX18xSensorChannelType.Null,modual.eX18xSensorChannelType.Null,modual.eX18xSensorChannelType.Null,modual.eX18xSensorChannelType.Null,modual.eX18xSensorChannelType.Null,modual.eX18xSensorChannelType.Null},          //东中转池     ID  53
                                                                                                                                                  {modual.eX18xSensorChannelType.Mike_7,modual.eX18xSensorChannelType.Weiertai,modual.eX18xSensorChannelType.Null,modual.eX18xSensorChannelType.Null,modual.eX18xSensorChannelType.Null,modual.eX18xSensorChannelType.Null,modual.eX18xSensorChannelType.Null,modual.eX18xSensorChannelType.Null},              //西西中转池   ID  6
                                                                                                                                                  {modual.eX18xSensorChannelType.Mike_6,modual.eX18xSensorChannelType.Null,modual.eX18xSensorChannelType.Null,modual.eX18xSensorChannelType.Null,modual.eX18xSensorChannelType.Null,modual.eX18xSensorChannelType.Null,modual.eX18xSensorChannelType.Null,modual.eX18xSensorChannelType.Null},                  //八角池       ID  21
                                                                                                                                                  {modual.eX18xSensorChannelType.Mike_5,modual.eX18xSensorChannelType.Null,modual.eX18xSensorChannelType.Null,modual.eX18xSensorChannelType.Null,modual.eX18xSensorChannelType.Null,modual.eX18xSensorChannelType.Null,modual.eX18xSensorChannelType.Null,modual.eX18xSensorChannelType.Null},                  //沉砂池       ID  12
                                                                                                                                                  {modual.eX18xSensorChannelType.Mike_6,modual.eX18xSensorChannelType.Null,modual.eX18xSensorChannelType.Null,modual.eX18xSensorChannelType.Null,modual.eX18xSensorChannelType.Null,modual.eX18xSensorChannelType.Null,modual.eX18xSensorChannelType.Null,modual.eX18xSensorChannelType.Null}};                 //匀浆池       ID  25
#endif
        private const byte byX18xReadDataStartAddress = 0;
        public const byte byX18xReadDataNumber = 8;
        private const byte byX18xReadTypeStartAddress = 10;
        private const byte byX18xReadTypeNumber = 8;
        public const double dX18xMinConvertData = 0;
        public const double dX18xMaxConvertData = 80;
        private const ushort dX18xMaxJumpData = 2;
        public static modual.pcx18X cx18x = new modual.pcx18X(byX18xIdlist, sX18xChannelType);
        private static _418X c18xformulasormual = new _418X();

#if DEBUG_TEST
        public const byte byX78cNumber = 1;
        public static byte[] byX78cIdlist = { 20 };
#else
        public  const byte  byX78cNumber                                = 0;
        public  static byte[] byX78cIdlist                              = {11,20,33,34,55,56};
#endif
        private const byte byX78cInputRegStartAddress = 0;
        public const byte byX78cInputRegNumber = 8;
        private const byte byX78cOutputRegStartAddress = 16;
        public const byte byX78cOutputRegNumber = 8;
        public static modual.pcx78C cx78c = new modual.pcx78C(byX78cIdlist);

#if DEBUG_TEST
        public const byte byX66cNumber = 5;
        public static byte[] byX66cIdlist = { 16, 31, 35, 39, 90 };
#else
        public  const byte  byX66cNumber                                = 32;
        public  static byte[] byX66cIdlist                              = {4,5,7,8,9,10,14,15,19,22,23,24,26,30,32,36,37,38,40,41,42,43,44,46,47,48,49,50,51,52,54,57};
#endif
        private const byte byX66cRelayRegStartAddress = 16;
        public const byte byX66cRelayRegNumber = 6;
        public static modual.pcx66C cx66c = new modual.pcx66C(byX66cIdlist);

        public const byte COMMFAILALARM = 3;
        public static void vAllNodePoll()
        {
            for (byte i = 0; i < byX14pNumber; i++)
            {
                ModbusComm.eModbusErrorCode ModbusErrorCode = ModbusComm.eModbusErrorCode.MB_EMASTERNOERR;
                string[][] sTempString = new string[byX14pNumber][];
                ModbusErrorCode |= ModbusComm.Modbus_ReadHoldingRegistersTask(out cx14P.sX14pDataStruct[i].usX14pRegData, cx14P.byModbusID[i], byX14pReadDataStartAddress, byX14pReadDataNumber);
                ModbusErrorCode |= ModbusComm.Modbus_ReadHoldingRegistersTask(out cx14P.sX14pDataStruct[i].usX14pRegType, cx14P.byModbusID[i], byX14pReadTypeStartAddress, byX14pReadTypeNumber);
                sTempString[i] = c14formulasormual.RtdValue(cx14P.sX14pDataStruct[i].usX14pRegData, cx14P.sX14pDataStruct[i].usX14pRegType);
                if (ModbusErrorCode != ModbusComm.eModbusErrorCode.MB_EMASTERNOERR)
                {
                    for (byte j = 0; j < byX14pReadTypeNumber; j++)
                    {
                        cx14P.sX14PAlarmStruct[i].usNowAlarmCode[j] |= (ushort)ModualAlarm.eAlarmCode.ChannelCommunError;
                        cx14P.sX14PAlarmStruct[i].usCommFailTimes[j]++;
                    }
                }
                else
                {
                    for (byte j = 0; j < byX14pReadTypeNumber; j++)
                    {
                        cx14P.sX14PAlarmStruct[i].usNowAlarmCode[j] &= (ushort)~ModualAlarm.eAlarmCode.ChannelCommunError;
                        cx14P.sX14PAlarmStruct[i].usCommFailTimes[j] = 0;
                    }
                }
                for (byte j = 0; j < byX14pReadTypeNumber; j++)
                {
                    cx14P.sX14pDataStruct[i].dNowConvertData[j] = double.Parse(sTempString[i][j]);
                    if (ModbusErrorCode == ModbusComm.eModbusErrorCode.MB_EMASTERNOERR)
                    {
                        switch (cx14P.eChannelType[i, j])
                        {
                            case modual.eX14pSensorChannelType.Normal:
                            cx14P.sX14pDataStruct[i].dNowConvertData[j] = cx14P.sX14pDataStruct[i].dNowConvertData[j];
                            break;
                            case modual.eX14pSensorChannelType.Null:
                            cx14P.sX14pDataStruct[i].dNowConvertData[j] = 0;
                            break;
                        }
                    }
                    else
                    {
                        cx14P.sX14pDataStruct[i].dNowConvertData[j] = 0;
                    }
                    if (cx14P.sX14PAlarmStruct[i].bDataNotFirstIncreaseOrDecrease == true && sX14pChannelType[i, j] != modual.eX14pSensorChannelType.Null)
                    {
                        if (cx14P.sX14pDataStruct[i].dNowConvertData[j] - cx14P.sX14pDataStruct[i].dBeforeConvertData[j] >= us14pMaxJumTemper || cx14P.sX14pDataStruct[i].dBeforeConvertData[j] - cx14P.sX14pDataStruct[i].dNowConvertData[j] >= us14pMaxJumTemper)
                        {
                            cx14P.sX14PAlarmStruct[i].usNowAlarmCode[j] |= (ushort)ModualAlarm.eAlarmCode.ChannelDataChangeError;
                        }
                        else
                        {
                            cx14P.sX14PAlarmStruct[i].usNowAlarmCode[j] &= (ushort)~ModualAlarm.eAlarmCode.ChannelDataChangeError;
                        }
                    }
                    if (cx14P.sX14pDataStruct[i].dNowConvertData[j] >= dx14pMaxConverData && sX14pChannelType[i, j] != modual.eX14pSensorChannelType.Null)
                    {
                        cx14P.sX14PAlarmStruct[i].usNowAlarmCode[j] |= (ushort)ModualAlarm.eAlarmCode.ChannelCollectDataError;
                    }
                    else
                    {
                        cx14P.sX14PAlarmStruct[i].usNowAlarmCode[j] &= (ushort)~ModualAlarm.eAlarmCode.ChannelCollectDataError;
                    }
                    cx14P.sX14pDataStruct[i].dBeforeConvertData[j] = cx14P.sX14pDataStruct[i].dNowConvertData[j];
                }
                cx14P.sX14PAlarmStruct[i].bDataNotFirstIncreaseOrDecrease = true;
            }

            for (byte i = 0; i < byX18xNumber; i++)
            {
                ModbusComm.eModbusErrorCode ModbusErrorCode = ModbusComm.eModbusErrorCode.MB_EMASTERNOERR;
                string[][] sTempString = new string[byX18xNumber][];
                ModbusErrorCode |= ModbusComm.Modbus_ReadHoldingRegistersTask(out cx18x.sX18xDataStruct[i].usRegData, cx18x.byModbusID[i], byX18xReadDataStartAddress, byX18xReadDataNumber);
                ModbusErrorCode |= ModbusComm.Modbus_ReadHoldingRegistersTask(out cx18x.sX18xDataStruct[i].usTypeData, cx18x.byModbusID[i], byX18xReadTypeStartAddress, byX18xReadTypeNumber);
                sTempString[i] = c18xformulasormual.Value(cx18x.sX18xDataStruct[i].usRegData, cx18x.sX18xDataStruct[i].usTypeData);
                if (ModbusErrorCode != ModbusComm.eModbusErrorCode.MB_EMASTERNOERR)
                {
                    for (sbyte j = 0; j < byX18xReadTypeNumber; j++)
                    {
                        cx18x.sX18xAlarmstruct[i].usNowAlarmCode[j] |= (ushort)ModualAlarm.eAlarmCode.ChannelCommunError;
                        cx18x.sX18xAlarmstruct[i].usCommFailTimes[j]++;
                    }
                }
                else
                {
                    for (sbyte j = 0; j < byX18xReadTypeNumber; j++)
                    {
                        cx18x.sX18xAlarmstruct[i].usNowAlarmCode[j] &= (ushort)~ModualAlarm.eAlarmCode.ChannelCommunError;
                        cx18x.sX18xAlarmstruct[i].usCommFailTimes[j] = 0;
                    }
                }
                for (byte j = 0; j < byX18xReadTypeNumber; j++)
                {
                    if (ModbusErrorCode == ModbusComm.eModbusErrorCode.MB_EMASTERNOERR)
                    {
                        switch (cx18x.beChannelType[i, j])
                        {
                            case modual.eX18xSensorChannelType.Weiertai:
                            cx18x.sX18xDataStruct[i].dNowConvertData[j] = 8 - ((double.Parse(sTempString[i][j]) - 4) / 16 * 8);
                            break;
                            case modual.eX18xSensorChannelType.Mike_5:
                            cx18x.sX18xDataStruct[i].dNowConvertData[j] = 5 - ((double.Parse(sTempString[i][j]) - 4) / 16 * 5);
                            break;
                            case modual.eX18xSensorChannelType.Mike_6:
                            cx18x.sX18xDataStruct[i].dNowConvertData[j] = 6 - ((double.Parse(sTempString[i][j]) - 4) / 16 * 6);
                            break;
                            case modual.eX18xSensorChannelType.Mike_7:
                            cx18x.sX18xDataStruct[i].dNowConvertData[j] = 7 - ((double.Parse(sTempString[i][j]) - 4) / 16 * 7);
                            break;
                            case modual.eX18xSensorChannelType.NormalCurrent:
                            cx18x.sX18xDataStruct[i].dNowConvertData[j] = double.Parse(sTempString[i][j]);
                            break;
                            case modual.eX18xSensorChannelType.Null:
                            cx18x.sX18xDataStruct[i].dNowConvertData[j] = 0;
                            break;
                            default:
                            break;
                        }
                    }
                    else
                    {
                        cx18x.sX18xDataStruct[i].dNowConvertData[j] = 0;
                    }
                    if (cx18x.sX18xAlarmstruct[i].bDataNotFirstIncreaseOrDecrease == true && sX18xChannelType[i, j] != modual.eX18xSensorChannelType.Null)
                    {
                        if (cx18x.sX18xDataStruct[i].dNowConvertData[j] - cx18x.sX18xDataStruct[i].dBeforeConvertData[j] >= dX18xMaxJumpData || cx18x.sX18xDataStruct[i].dBeforeConvertData[j] - cx18x.sX18xDataStruct[i].dNowConvertData[j] >= dX18xMaxJumpData)
                        {
                            cx18x.sX18xAlarmstruct[i].usNowAlarmCode[j] |= (ushort)ModualAlarm.eAlarmCode.ChannelDataChangeError;
                        }
                        else
                        {
                            cx18x.sX18xAlarmstruct[i].usNowAlarmCode[j] &= (ushort)~ModualAlarm.eAlarmCode.ChannelDataChangeError;
                        }
                    }
                    if ((cx18x.sX18xDataStruct[i].dNowConvertData[j] >= dX18xMaxConvertData || cx18x.sX18xDataStruct[i].dNowConvertData[j] <= dX18xMinConvertData) && sX18xChannelType[i, j] != modual.eX18xSensorChannelType.Null)
                    {
                        cx18x.sX18xAlarmstruct[i].usNowAlarmCode[j] |= (ushort)ModualAlarm.eAlarmCode.ChannelCollectDataError;
                    }
                    else
                    {
                        cx18x.sX18xAlarmstruct[i].usNowAlarmCode[j] &= (ushort)~ModualAlarm.eAlarmCode.ChannelCollectDataError;
                    }
                    cx18x.sX18xDataStruct[i].dBeforeConvertData[j] = cx18x.sX18xDataStruct[i].dNowConvertData[j];
                }
                cx18x.sX18xAlarmstruct[i].bDataNotFirstIncreaseOrDecrease = true;
            }
            for (byte i = 0; i < byX78cNumber; i++)
            {
                ModbusComm.eModbusErrorCode ModbusErrorCode = ModbusComm.eModbusErrorCode.MB_EMASTERNOERR;
                ModbusErrorCode |= ModbusComm.Modbus_ReadCoilsTask(out cx78c.sX78cRegStatusStruct[i].bInputRegStatus, cx78c.byModbusID[i], byX78cInputRegStartAddress, byX78cInputRegNumber);
                ModbusErrorCode |= ModbusComm.Modbus_ReadCoilsTask(out cx78c.sX78cRegStatusStruct[i].bOutPutRegStatus, cx78c.byModbusID[i], byX78cOutputRegStartAddress, byX78cOutputRegNumber);
                if (ModbusErrorCode != ModbusComm.eModbusErrorCode.MB_EMASTERNOERR)
                {
                    for (sbyte j = 0; j < byX78cInputRegNumber + byX78cOutputRegNumber; j++)
                    {
                        cx78c.sX78cAlarmStruct[i].usNowAlarmCode[j] |= (ushort)ModualAlarm.eAlarmCode.ChannelCommunError;
                        cx78c.sX78cAlarmStruct[i].usCommFailTimes[j]++;
                    }
                }
                else
                {
                    for (sbyte j = 0; j < byX78cInputRegNumber + byX78cOutputRegNumber; j++)
                    {
                        cx78c.sX78cAlarmStruct[i].usNowAlarmCode[j] &= (ushort)~ModualAlarm.eAlarmCode.ChannelCommunError;
                        cx78c.sX78cAlarmStruct[i].usCommFailTimes[j] = 0;
                    }
                }
            }

            for (byte i = 0; i < byX66cNumber; i++)
            {
                ModbusComm.eModbusErrorCode ModbusErrorCode = ModbusComm.eModbusErrorCode.MB_EMASTERNOERR;
                ModbusErrorCode = ModbusComm.Modbus_ReadCoilsTask(out cx66c.sX66cRegStatusStruct[i].bRegRelayStatus, cx66c.byModbusID[i], byX66cRelayRegStartAddress, byX66cRelayRegNumber);
                if (ModbusErrorCode != ModbusComm.eModbusErrorCode.MB_EMASTERNOERR)
                {
                    for (sbyte j = 0; j < byX66cRelayRegNumber; j++)
                    {
                        cx66c.sX66cAlarmStruct[i].usNowAlarmCode[j] |= (ushort)ModualAlarm.eAlarmCode.ChannelCommunError;
                        cx66c.sX66cAlarmStruct[i].usCommFailTimes[j]++;
                    }
                }
                else
                {
                    for (sbyte j = 0; j < byX66cRelayRegNumber; j++)
                    {
                        cx66c.sX66cAlarmStruct[i].usNowAlarmCode[j] &= (ushort)~ModualAlarm.eAlarmCode.ChannelCommunError;
                        cx66c.sX66cAlarmStruct[i].usCommFailTimes[j] = 0;
                    }
                }
            }
        }
        public static string stAll_Poll_Package()
        {
            string stPollString;
            stPollString = "[";
            for (sbyte i = 0; i < byX14pNumber; i++)
            {
                string stIdString = cx14P.byModbusID[i].ToString();
                WTDR14P OneNodeJsonPackage = new WTDR14P(stIdString, cx14P.sX14pDataStruct[i].dNowConvertData[0], cx14P.sX14pDataStruct[i].dNowConvertData[1], cx14P.sX14pDataStruct[i].dNowConvertData[2], cx14P.sX14pDataStruct[i].dNowConvertData[3], Form1.GetTimeStamp());
                stPollString += JsonConvert.SerializeObject(OneNodeJsonPackage) + ",";
            }
            for (sbyte i = 0; i < byX18xNumber; i++)
            {
                string stIdString = cx18x.byModbusID[i].ToString();
                WTDR18X OneNodeJsonPackage = new WTDR18X(stIdString, cx18x.sX18xDataStruct[i].dNowConvertData[0], cx18x.sX18xDataStruct[i].dNowConvertData[1], cx18x.sX18xDataStruct[i].dNowConvertData[2], cx18x.sX18xDataStruct[i].dNowConvertData[3], cx18x.sX18xDataStruct[i].dNowConvertData[4], cx18x.sX18xDataStruct[i].dNowConvertData[5], cx18x.sX18xDataStruct[i].dNowConvertData[6], cx18x.sX18xDataStruct[i].dNowConvertData[7], Form1.GetTimeStamp());
                stPollString += JsonConvert.SerializeObject(OneNodeJsonPackage) + ",";
            }
            for (sbyte i = 0; i < byX78cNumber; i++)
            {
                string stIdString = cx78c.byModbusID[i].ToString();
                _478C cBoolConvertInt = new _478C();
                int[] InputConvert, OutPutConver;
                InputConvert = cBoolConvertInt.IO(cx78c.sX78cRegStatusStruct[i].bInputRegStatus);
                OutPutConver = cBoolConvertInt.IO(cx78c.sX78cRegStatusStruct[i].bOutPutRegStatus);
                WTDR78C OneNodeJsonPackage = new WTDR78C(stIdString, InputConvert[0], InputConvert[1], InputConvert[2], InputConvert[3], InputConvert[4], InputConvert[5], InputConvert[6], InputConvert[7], OutPutConver[0], OutPutConver[1], OutPutConver[2], OutPutConver[3], OutPutConver[4], OutPutConver[5], OutPutConver[6], OutPutConver[7], Form1.GetTimeStamp());
                stPollString += JsonConvert.SerializeObject(OneNodeJsonPackage) + ",";
            }

            for (sbyte i = 0; i < byX66cNumber; i++)
            {
                string stIdString = cx66c.byModbusID[i].ToString();
                _478C cBoolConvertInt = new _478C();
                int[] sRelayConvert;
                sRelayConvert = cBoolConvertInt.IO(cx66c.sX66cRegStatusStruct[i].bRegRelayStatus);
                WTDR66C OneNodeJsonPackage = new WTDR66C(stIdString, sRelayConvert[0], sRelayConvert[1], sRelayConvert[2], sRelayConvert[3], sRelayConvert[4], sRelayConvert[5], Form1.GetTimeStamp());
                if (i >= byX66cNumber - 1)
                {
                    stPollString += JsonConvert.SerializeObject(OneNodeJsonPackage) + "]";
                    return stPollString;
                }
                else
                    stPollString += JsonConvert.SerializeObject(OneNodeJsonPackage) + ",";
            }
            return stPollString;
        }
        public static async void vCheckAlarm_And_Send(IMqttClient mqttClient)
        {
            bool bOccurErrorChange = false;
            ModualAlarm.sAlarmJson = "[";
            for (byte i = 0; i < byX14pNumber; i++)
            {
                bool bX14pError = false;
                List<ushort> usChannelErrorlist = new List<ushort>();
                List<ushort> usChannelErrorCodeList = new List<ushort>();
                for (byte j = 0; j < byX14pReadDataNumber; j++)
                {
                    if ((cx14P.sX14PAlarmStruct[i].usNowAlarmCode[j] & (ushort)ModualAlarm.eAlarmCode.ChannelCommunError) == (ushort)ModualAlarm.eAlarmCode.ChannelCommunError && cx14P.sX14PAlarmStruct[i].usCommFailTimes[j] < COMMFAILALARM)
                    {
                        cx14P.sX14PAlarmStruct[i].usNowAlarmCode[j] &= (ushort)~ModualAlarm.eAlarmCode.ChannelCommunError;
                    }
                    if (cx14P.sX14PAlarmStruct[i].usNowAlarmCode[j] != cx14P.sX14PAlarmStruct[i].usBeforeAlarmCode[j])
                    {
                        bOccurErrorChange = true;
                        bX14pError = true;
                        usChannelErrorlist.Add(j);
                        usChannelErrorCodeList.Add((ushort)cx14P.sX14PAlarmStruct[i].usNowAlarmCode[j]);
                    }
                    cx14P.sX14PAlarmStruct[i].usBeforeAlarmCode[j] = cx14P.sX14PAlarmStruct[i].usNowAlarmCode[j];
                }
                if (bX14pError == true)
                {
                    ushort[] usChannelList = usChannelErrorlist.ToArray();
                    ushort[] usCodeList = usChannelErrorCodeList.ToArray();
                    ModualAlarm.vSetAlarmList(cx14P.byModbusID[i], usChannelList, usCodeList);
                }
            }
            for (byte i = 0; i < byX18xNumber; i++)
            {
                bool bX18xError = false;
                List<ushort> usChannelErrorlist = new List<ushort>();
                List<ushort> usChannelErrorCodeList = new List<ushort>();
                for (byte j = 0; j < byX18xReadTypeNumber; j++)
                {
                    if ((cx18x.sX18xAlarmstruct[i].usNowAlarmCode[j] & (ushort)ModualAlarm.eAlarmCode.ChannelCommunError) == (ushort)ModualAlarm.eAlarmCode.ChannelCommunError && cx18x.sX18xAlarmstruct[i].usCommFailTimes[j] < COMMFAILALARM)
                    {
                        cx18x.sX18xAlarmstruct[i].usNowAlarmCode[j] &= (ushort)~ModualAlarm.eAlarmCode.ChannelCommunError;
                    }
                    if (cx18x.sX18xAlarmstruct[i].usNowAlarmCode[j] != cx18x.sX18xAlarmstruct[i].usBeforeAlarmCode[j])
                    {
                        bX18xError = true;
                        bOccurErrorChange = true;
                        usChannelErrorlist.Add(j);
                        usChannelErrorCodeList.Add((ushort)cx18x.sX18xAlarmstruct[i].usNowAlarmCode[j]);
                    }
                    cx18x.sX18xAlarmstruct[i].usBeforeAlarmCode[j] = cx18x.sX18xAlarmstruct[i].usNowAlarmCode[j];
                }
                if (bX18xError == true)
                {
                    ushort[] usChannelList = usChannelErrorlist.ToArray();
                    ushort[] usCodeList = usChannelErrorCodeList.ToArray();
                    ModualAlarm.vSetAlarmList(cx18x.byModbusID[i], usChannelList, usCodeList);
                }
            }

            for (byte i = 0; i < byX78cNumber; i++)
            {
                bool bX78CError = false;
                List<ushort> usChannelErrorlist = new List<ushort>();
                List<ushort> usChannelErrorCodeList = new List<ushort>();
                for (byte j = 0; j < byX78cOutputRegNumber + byX78cInputRegNumber; j++)
                {
                    if ((cx78c.sX78cAlarmStruct[i].usNowAlarmCode[j] & (ushort)ModualAlarm.eAlarmCode.ChannelCommunError) == (ushort)ModualAlarm.eAlarmCode.ChannelCommunError && cx78c.sX78cAlarmStruct[i].usCommFailTimes[j] < COMMFAILALARM)
                    {
                        cx78c.sX78cAlarmStruct[i].usNowAlarmCode[j] &= (ushort)~ModualAlarm.eAlarmCode.ChannelCommunError;
                    }
                    if (cx78c.sX78cAlarmStruct[i].usNowAlarmCode[j] != cx78c.sX78cAlarmStruct[i].usBeforeAlarmCode[j])
                    {
                        bOccurErrorChange = true;
                        bX78CError = true;
                        usChannelErrorlist.Add(j);
                        usChannelErrorCodeList.Add((ushort)cx78c.sX78cAlarmStruct[i].usNowAlarmCode[j]);
                    }
                    cx78c.sX78cAlarmStruct[i].usBeforeAlarmCode[j] = cx78c.sX78cAlarmStruct[i].usNowAlarmCode[j];
                }
                if (bX78CError == true)
                {
                    ushort[] usChannelList = usChannelErrorlist.ToArray();
                    ushort[] usCodeList = usChannelErrorCodeList.ToArray();
                    ModualAlarm.vSetAlarmList(cx78c.byModbusID[i], usChannelList, usCodeList);
                }
            }

            for (byte i = 0; i < byX66cNumber; i++)
            {
                bool bX66cError = false;
                List<ushort> usChannelErrorlist = new List<ushort>();
                List<ushort> usChannelErrorCodeList = new List<ushort>();
                for (byte j = 0; j < byX66cRelayRegNumber; j++)
                {
                    if ((cx66c.sX66cAlarmStruct[i].usNowAlarmCode[j] & (ushort)ModualAlarm.eAlarmCode.ChannelCommunError) == (ushort)ModualAlarm.eAlarmCode.ChannelCommunError && cx66c.sX66cAlarmStruct[i].usCommFailTimes[j] < COMMFAILALARM)
                    {
                        cx66c.sX66cAlarmStruct[i].usNowAlarmCode[j] &= (ushort)~ModualAlarm.eAlarmCode.ChannelCommunError;
                    }
                    if (cx66c.sX66cAlarmStruct[i].usNowAlarmCode[j] != cx66c.sX66cAlarmStruct[i].usBeforeAlarmCode[j])
                    {
                        bOccurErrorChange = true;
                        bX66cError = true;
                        usChannelErrorlist.Add(j);
                        usChannelErrorCodeList.Add((ushort)cx66c.sX66cAlarmStruct[i].usNowAlarmCode[j]);
                    }
                    cx66c.sX66cAlarmStruct[i].usBeforeAlarmCode[j] = cx66c.sX66cAlarmStruct[i].usNowAlarmCode[j];
                }
                if (bX66cError == true)
                {
                    ushort[] usChannelList = usChannelErrorlist.ToArray();
                    ushort[] usCodeList = usChannelErrorCodeList.ToArray();
                    ModualAlarm.vSetAlarmList(cx66c.byModbusID[i], usChannelList, usCodeList);
                }
            }
            if (bOccurErrorChange == true)
            {
                ModualAlarm.sAlarmJson += "]";
                await ModualAlarm.vPublishAlarmPackageJson(mqttClient);
            }
        }

        public static bool bGet_channel_Value<T> (byte byModbusID, out T[] ChannnelData, params string[] strChannelList)
        {
            ModbusComm.eModbusErrorCode ModbusErrorCode = ModbusComm.eModbusErrorCode.MB_EMASTERNOERR;
            bool bGetStatus = true;
            List<T> arrayList = new List<T>();
            ushort[] usRegValue, usRegType;
            string[] strCalculData;

            ChannnelData = (T[]) arrayList.ToArray();
            for (int i = 0; i < ModualPoll.byX18xNumber; i++)
            {
                if (byModbusID == ModualPoll.cx18x.byModbusID[i])
                {
                    if ((ModbusErrorCode |= ModbusComm.Modbus_ReadHoldingRegistersTask(out usRegValue, byModbusID, byX18xReadDataStartAddress, byX18xReadDataNumber)) == ModbusComm.eModbusErrorCode.MB_EMASTERNOERR)
                    {
                        ModualAlarm.vSet_Modual_Alarm(byModbusID, (ushort)ModualAlarm.eAlarmCode.ChannelCommunError, false, 1, "d0", "d1", "d2", "d3", "d4", "d5", "d6", "d7");
                    }
                    else
                    {
                        ModualAlarm.vSet_Modual_Alarm(byModbusID, (ushort)ModualAlarm.eAlarmCode.ChannelCommunError, true, 1, "d0", "d1", "d2", "d3", "d4", "d5", "d6", "d7");
                        bGetStatus = false;
                    }
                    if ((ModbusErrorCode |= ModbusComm.Modbus_ReadHoldingRegistersTask(out usRegType, byModbusID, byX18xReadTypeStartAddress, byX18xReadTypeNumber)) == ModbusComm.eModbusErrorCode.MB_EMASTERNOERR)
                    {
                        ModualAlarm.vSet_Modual_Alarm(byModbusID, (ushort)ModualAlarm.eAlarmCode.ChannelCommunError, false, 1, "d0", "d1", "d2", "d3", "d4", "d5", "d6", "d7");
                    }
                    else
                    {
                        ModualAlarm.vSet_Modual_Alarm(byModbusID, (ushort)ModualAlarm.eAlarmCode.ChannelCommunError, true, 1, "d0", "d1", "d2", "d3", "d4", "d5", "d6", "d7");
                        bGetStatus = false;
                    }
                    strCalculData = c18xformulasormual.Value(usRegValue, usRegType);
                    for (int j = 0; j < strChannelList.Count(); j++)
                    {
                        for (int k = 0; k < byX18xReadTypeNumber; k++)
                        {
                            string str = "d" + k.ToString();
                            if (str == strChannelList[j])
                            {
                                switch (cx18x.beChannelType[i, k])
                                {
                                    case modual.eX18xSensorChannelType.Weiertai:
                                    arrayList.Add((T)Convert.ChangeType(8 - ((double.Parse(strCalculData[k]) - 4) / 16 * 8), typeof(T)));
                                    break;
                                    case modual.eX18xSensorChannelType.Mike_5:
                                    arrayList.Add((T)Convert.ChangeType(5 - ((double.Parse(strCalculData[k]) - 4) / 16 * 5), typeof(T)));
                                    break;
                                    case modual.eX18xSensorChannelType.Mike_6:
                                    arrayList.Add((T)Convert.ChangeType(6 - ((double.Parse(strCalculData[k]) - 4) / 16 * 6), typeof(T)));
                                    break;
                                    case modual.eX18xSensorChannelType.Mike_7:
                                    arrayList.Add((T)Convert.ChangeType(7 - ((double.Parse(strCalculData[k]) - 4) / 16 * 7), typeof(T)));
                                    break;
                                    case modual.eX18xSensorChannelType.NormalCurrent:
                                    arrayList.Add((T)Convert.ChangeType(double.Parse(strCalculData[k]), typeof(T)));
                                    break;
                                    case modual.eX18xSensorChannelType.Null:
                                    arrayList.Add((T)Convert.ChangeType(0, typeof(T)));
                                    break;
                                    default:
                                    break;
                                }
                            }

                        }
                    }
                    ChannnelData = (T[]) arrayList.ToArray();
                }
            }
            for (int i = 0; i < ModualPoll.byX14pNumber; i++)
            {
                if (byModbusID == ModualPoll.cx14P.byModbusID[i])
                {

                    if ((ModbusErrorCode |= ModbusComm.Modbus_ReadHoldingRegistersTask(out usRegValue, byModbusID, byX14pReadDataStartAddress, byX14pReadDataNumber)) == ModbusComm.eModbusErrorCode.MB_EMASTERNOERR)
                    {
                        ModualAlarm.vSet_Modual_Alarm(byModbusID,  (ushort)ModualAlarm.eAlarmCode.ChannelCommunError, false, 1, "d0", "d1", "d2", "d3", "d4", "d5", "d6", "d7");
                    }
                    else
                    {
                        ModualAlarm.vSet_Modual_Alarm(byModbusID,  (ushort)ModualAlarm.eAlarmCode.ChannelCommunError, true, 1, "d0", "d1", "d2", "d3", "d4", "d5", "d6", "d7");
                        bGetStatus = false;
                    }
                    if ((ModbusErrorCode |= ModbusComm.Modbus_ReadHoldingRegistersTask(out usRegType, byModbusID, byX14pReadTypeStartAddress, byX14pReadTypeNumber)) == ModbusComm.eModbusErrorCode.MB_EMASTERNOERR)
                    {
                        ModualAlarm.vSet_Modual_Alarm(byModbusID,  (ushort)ModualAlarm.eAlarmCode.ChannelCommunError, false, 1, "d0", "d1", "d2", "d3", "d4", "d5", "d6", "d7");
                    }
                    else
                    {
                        ModualAlarm.vSet_Modual_Alarm(byModbusID,  (ushort)ModualAlarm.eAlarmCode.ChannelCommunError, true, 1, "d0", "d1", "d2", "d3", "d4", "d5", "d6", "d7");
                        bGetStatus = false;
                    }
                    strCalculData = c14formulasormual.RtdValue(usRegValue, usRegType);
                    for (int j = 0; j < strChannelList.Count(); j++)
                    {
                        for (int k = 0; k < byX14pReadTypeNumber; k++)
                        {
                            string str = "d" + k.ToString();
                            if (str == strChannelList[j])
                            {
                                 arrayList.Add((T)Convert.ChangeType(strCalculData, typeof(T)));
                            }
                        }
                    }
                    ChannnelData = (T[]) arrayList.ToArray();
                }
            }
            for (int i = 0; i < ModualPoll.byX78cNumber; i++)
            {
                bool[] bInputData, bOutPutData;
                if (byModbusID == ModualPoll.cx78c.byModbusID[i])
                {
                    if ((ModbusErrorCode |= ModbusComm.Modbus_ReadCoilsTask(out bInputData, byModbusID, byX78cInputRegStartAddress, byX78cInputRegNumber)) == ModbusComm.eModbusErrorCode.MB_EMASTERNOERR)
                    {
                        ModualAlarm.vSet_Modual_Alarm(byModbusID, (ushort)ModualAlarm.eAlarmCode.ChannelCommunError, false, 1, "d0", "d1", "d2", "d3", "d4", "d5", "d6", "d7");
                    }
                    else
                    {
                        ModualAlarm.vSet_Modual_Alarm(byModbusID, (ushort)ModualAlarm.eAlarmCode.ChannelCommunError, true, 1, "d0", "d1", "d2", "d3", "d4", "d5", "d6", "d7");
                        bGetStatus = false;
                    }
                    if ((ModbusErrorCode |= ModbusComm.Modbus_ReadCoilsTask(out bOutPutData, byModbusID, byX78cOutputRegStartAddress, byX78cOutputRegNumber)) == ModbusComm.eModbusErrorCode.MB_EMASTERNOERR)
                    {
                        ModualAlarm.vSet_Modual_Alarm(byModbusID, (ushort)ModualAlarm.eAlarmCode.ChannelCommunError, false, 1, "d0", "d1", "d2", "d3", "d4", "d5", "d6", "d7");
                    }
                    else
                    {
                        ModualAlarm.vSet_Modual_Alarm(byModbusID, (ushort)ModualAlarm.eAlarmCode.ChannelCommunError, true, 1, "d0", "d1", "d2", "d3", "d4", "d5", "d6", "d7");
                        bGetStatus = false;
                    }
                    for (int j = 0; j < strChannelList.Count(); j++)
                    {
                        for (int k = 0; k < byX78cInputRegNumber; k++)
                        {
                            string str = "d" + k.ToString();
                            if (str == strChannelList[j])
                            {
                                arrayList.Add((T)Convert.ChangeType(bInputData[j], typeof(T)));
                            }
                        }
                        for (int k = byX78cInputRegNumber; k < byX78cOutputRegNumber + byX78cInputRegNumber; k++)
                        {
                            string str = "d" + k.ToString();
                            if (str == strChannelList[j])
                            {
                                arrayList.Add((T)Convert.ChangeType(bOutPutData[j],typeof(T)));
                            }
                        }
                    }
                     ChannnelData = (T[]) arrayList.ToArray();
                }
            }
            for (int i = 0; i < ModualPoll.byX66cNumber; i++)
            {
                if (byModbusID == ModualPoll.cx66c.byModbusID[i])
                {
                    bool[] bRelayValue;
                    if ((ModbusErrorCode |= ModbusComm.Modbus_ReadCoilsTask(out bRelayValue, byModbusID, byX66cRelayRegStartAddress, byX66cRelayRegNumber)) == ModbusComm.eModbusErrorCode.MB_EMASTERNOERR)
                    {
                        ModualAlarm.vSet_Modual_Alarm(byModbusID, (ushort)ModualAlarm.eAlarmCode.ChannelCommunError, false, 1, "d0", "d1", "d2", "d3", "d4", "d5", "d6", "d7");
                    }
                    else
                    {
                        ModualAlarm.vSet_Modual_Alarm(byModbusID, (ushort)ModualAlarm.eAlarmCode.ChannelCommunError, true, 1, "d0", "d1", "d2", "d3", "d4", "d5", "d6", "d7");
                        bGetStatus = false;
                    }
                    for (int j = 0; j < strChannelList.Count() && j < byX66cRelayRegNumber; j++)
                    {
                        for (int k = 0; k < byX66cRelayRegNumber; k++)
                        {
                            string str = "d" + k.ToString();
                            if (str == strChannelList[j])
                            {
                               arrayList.Add((T)Convert.ChangeType(bRelayValue[j],typeof(T)));
                            }
                        }
                    }
                   ChannnelData = (T[]) arrayList.ToArray();
                }
            }
            if (arrayList.Count() == 0)
            {
                for (int i = 0; i < strChannelList.Count(); i++)
                {
                    arrayList.Add((T)Convert.ChangeType(0, typeof(T)));
                }
            }
            ChannnelData = (T[]) arrayList.ToArray();
            return bGetStatus;

        }

        public static bool bSet_All_Channel_Value(byte byModbusID, bool[] bControlData)
        {
            bool bControlStatus = true;
            for (int i = 0; i < ModualPoll.byX66cNumber; i++)
            {
                if (byModbusID == ModualPoll.cx66c.byModbusID[i])
                {
                    if ((ModbusComm.Modbus_WriteMultipleCoils(byModbusID, byX66cRelayRegStartAddress, bControlData)) == ModbusComm.eModbusErrorCode.MB_EMASTERNOERR)
                    {
                        ModualAlarm.vSet_Modual_Alarm(byModbusID, (ushort)ModualAlarm.eAlarmCode.ChannelCommunError, false, 1, "d0", "d1", "d2", "d3", "d4", "d5", "d6", "d7");
                    }
                    else
                    {
                        ModualAlarm.vSet_Modual_Alarm(byModbusID, (ushort)ModualAlarm.eAlarmCode.ChannelCommunError, true, 1, "d0", "d1", "d2", "d3", "d4", "d5", "d6", "d7");
                        bControlStatus = false;
                    }
                }
            }

            for (int i = 0; i < ModualPoll.byX78cNumber; i++)
            {
                if (byModbusID == ModualPoll.cx78c.byModbusID[i])
                {
                    if ((ModbusComm.Modbus_WriteMultipleCoils(byModbusID, byX78cOutputRegStartAddress, bControlData)) == ModbusComm.eModbusErrorCode.MB_EMASTERNOERR)
                    {
                        ModualAlarm.vSet_Modual_Alarm(byModbusID, (ushort)ModualAlarm.eAlarmCode.ChannelCommunError, false, 1, "d0", "d1", "d2", "d3", "d4", "d5", "d6", "d7");
                    }
                    else
                    {
                        ModualAlarm.vSet_Modual_Alarm(byModbusID, (ushort)ModualAlarm.eAlarmCode.ChannelCommunError, true, 1, "d0", "d1", "d2", "d3", "d4", "d5", "d6", "d7");
                        bControlStatus = false;
                    }
                }
            }
            return bControlStatus;
        }
    }
}

