﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using ModbusDemo.MessageFormat;
using ModbusDemo.Common;
namespace ModbusDemo.Modular
{
    public class modual
    {
        public  struct psx14pData
        {
            public ushort[]  usX14pRegData;
            public ushort[]  usX14pRegType;
            public double[]  dNowConvertData;
            public double[]  dBeforeConvertData;
        }
        public enum eX14pSensorChannelType : byte
        {
            Normal = 0,
            Null,
        }
        public enum eModualType : byte
        {
            IDLE   = 0,
            WTDR14P,
            WTDR18X,
            WTDR78C,
            WTDR66C,
        }
        public struct psxModualAlarm
        {
            public bool     bDataNotFirstIncreaseOrDecrease;
            public ushort[] usNowAlarmCode;
            public ushort[] usBeforeAlarmCode;
            public ushort[] usCommFailTimes;
        }
        public class pcx14P
        {
            public byte[]                          byModbusID;
            public psx14pData[]                    sX14pDataStruct   = new psx14pData[ModualPoll.byX14pNumber];
            public psxModualAlarm[]                sX14PAlarmStruct  = new psxModualAlarm[ModualPoll.byX14pNumber];
            public eX14pSensorChannelType[,] eChannelType;
            public pcx14P(byte[] InitIDlist, eX14pSensorChannelType[,] ChannelType)
            {
                this.byModbusID   = InitIDlist;
                this.eChannelType = ChannelType;
                for (byte i = 0; i < ModualPoll.byX14pNumber; i++)
                {
                    this.sX14pDataStruct[i].dBeforeConvertData = new double[ModualPoll.byX14pReadDataNumber];
                    this.sX14pDataStruct[i].dNowConvertData    = new double[ModualPoll.byX14pReadDataNumber];
                    //this.sX14pDataStruct[i].usX14pRegType      = new ushort[ModualPoll.byX14pReadDataNumber];
                    //this.sX14pDataStruct[i].usX14pRegData      = new ushort[ModualPoll.byX14pReadDataNumber];
                    this.sX14PAlarmStruct[i].usBeforeAlarmCode  = new ushort[ModualPoll.byX14pReadDataNumber];
                    this.sX14PAlarmStruct[i].usNowAlarmCode     = new ushort[ModualPoll.byX14pReadDataNumber];
                    this.sX14PAlarmStruct[i].usCommFailTimes    = new ushort[ModualPoll.byX14pReadDataNumber];
                }
            }
        }
        public enum eX18xSensorChannelType : byte
        {
            Null   = 0,
            Weiertai,
            Mike_5,
            Mike_6,
            Mike_7,
            NormalCurrent,
        }

        public struct psX18xData
        {
            public ushort[]                     usRegData;
            public ushort[]                     usTypeData;
            public double[]                     dNowConvertData;
            public double[]                     dBeforeConvertData;
        }
        public class pcx18X
        {
            public  byte[]                          byModbusID;
            public  psX18xData[]                    sX18xDataStruct  = new psX18xData[ModualPoll.byX18xNumber];
            public  psxModualAlarm[]                sX18xAlarmstruct = new psxModualAlarm[ModualPoll.byX18xNumber];
            public  eX18xSensorChannelType[,]       beChannelType;
            public pcx18X(byte[] InitIDlist, eX18xSensorChannelType[,] eChannnelType)
            {
                this.byModbusID         = InitIDlist;
                this.beChannelType      = eChannnelType;
                for (byte i = 0; i < ModualPoll.byX18xNumber; i++)
                {
                    this.sX18xDataStruct[i].dBeforeConvertData      = new double[ModualPoll.byX18xReadDataNumber];
                    this.sX18xDataStruct[i].dNowConvertData         = new double[ModualPoll.byX18xReadDataNumber];
                    //this.sX18xDataStruct[i].usRegData               = new ushort[ModualPoll.byX18xReadDataNumber];
                    //this.sX18xDataStruct[i].usTypeData              = new ushort[ModualPoll.byX18xReadDataNumber];
                    this.sX18xAlarmstruct[i].usBeforeAlarmCode      = new ushort[ModualPoll.byX18xReadDataNumber];
                    this.sX18xAlarmstruct[i].usNowAlarmCode         = new ushort[ModualPoll.byX18xReadDataNumber];
                    this.sX18xAlarmstruct[i].usCommFailTimes        = new ushort[ModualPoll.byX18xReadDataNumber];
                }
            }
        }
        public struct psx78C
        {
            public bool[] bInputRegStatus;
            public bool[] bOutPutRegStatus;
        }
        public class pcx78C
        {
            public byte[]                              byModbusID;
            public psx78C[]                            sX78cRegStatusStruct = new psx78C[ModualPoll.byX78cNumber];
            public psxModualAlarm[]                    sX78cAlarmStruct     = new psxModualAlarm[ModualPoll.byX78cNumber];
            public pcx78C(byte[] InitIDlist)
            {
                this.byModbusID = InitIDlist;
                for (byte i = 0; i < ModualPoll.byX78cNumber; i++)
                {
                    this.sX78cRegStatusStruct[i].bInputRegStatus    = new bool[ModualPoll.byX78cInputRegNumber];
                    this.sX78cRegStatusStruct[i].bOutPutRegStatus   = new bool[ModualPoll.byX78cOutputRegNumber];
                    this.sX78cAlarmStruct[i].usBeforeAlarmCode      = new ushort[ModualPoll.byX78cInputRegNumber + ModualPoll.byX78cOutputRegNumber];
                    this.sX78cAlarmStruct[i].usNowAlarmCode         = new ushort[ModualPoll.byX78cInputRegNumber + ModualPoll.byX78cOutputRegNumber];
                    this.sX78cAlarmStruct[i].usCommFailTimes        = new ushort[ModualPoll.byX78cInputRegNumber + ModualPoll.byX78cOutputRegNumber];
                }
            }
        }
        public struct psx66C
        {
            public bool[] bRegRelayStatus;
        }
        public class pcx66C
        {
            public byte[]                          byModbusID;
            public psx66C[]                        sX66cRegStatusStruct = new psx66C[ModualPoll.byX66cNumber];
            public psxModualAlarm[]                sX66cAlarmStruct     = new psxModualAlarm[ModualPoll.byX66cNumber];
            public pcx66C(byte[] InitIDlist)
            {
                this.byModbusID = InitIDlist;
                for (byte i = 0; i < ModualPoll.byX66cNumber; i++)
                {
                    this.sX66cRegStatusStruct[i].bRegRelayStatus    = new bool[ModualPoll.byX66cRelayRegNumber];
                    this.sX66cAlarmStruct[i].usBeforeAlarmCode      = new ushort[ModualPoll.byX66cRelayRegNumber];
                    this.sX66cAlarmStruct[i].usNowAlarmCode         = new ushort[ModualPoll.byX66cRelayRegNumber];
                    this.sX66cAlarmStruct[i].usCommFailTimes        = new ushort[ModualPoll.byX66cRelayRegNumber];
                }
            }
        }
    }
}
